<cfimport prefix="g" taglib="../../groovyEngine/tags" />

<!---
Again, we have an application-scoped runtime, this time with a groovy
path configured.
--->

<cfscript>
a = [];
month = createDate(year(now()), month(now()), 1);
for (i = 1; i LTE 6; i = i + 1) {
	s = {
		letter = chr(65 + randRange(0, 25)),
		date = dateAdd("d", randRange(0, 27), month)
	};
	arrayAppend(a, s);
}
</cfscript>

<h1>Comparators</h1>

<p>Here we're doing some sorting of complex values using Java <code>Comparator</code>s.
An array of six structs is created, each with a random letter and random date inside.  That's
what's dumped in the first column.  In the second column, they've been sorted by letter using
a Groovy closure to implement <code>Comparator</code>.  In the third column, they've been
sorted by date descending using an actual Comparator implementation (a Groovy class).
</p>

<cfif structKeyExists(server, "railo") AND server.railo["release-date"] LTE createDate(2008, 6, 27)>
	<p><strong style="color:red;">On Railo 3.0.0.002 and below only</strong>, no sorting happens.  There is
	<a href="http://jira.jboss.org/jira/browse/RAILO-31">a bug (which has been resolved)</a> that prevents
	<code>Collections.sort</code> from making changes to the array being sorted.  Later versions of Railo
	do not have this problem.
	</p>
</cfif>

<table>
<tr>
	<th>Randomized</th>
	<th>Sorted by Letter (closure)</th>
	<th>Reverse Sorted by Date (class)</th>
</tr>
<tr>
<td>
<cfdump var="#a#" />
</td>
<td>
<g:script>
Collections.sort(variables.a, {o1, o2 ->
	o1.letter.compareTo(o2.letter)
} as Comparator)
</g:script>
<cfdump var="#a#" />
</td>
<td>
<g:script>
Collections.sort(variables.a, new ReverseDateKeyComparator())
</g:script>
<cfdump var="#a#" />
</td>
</tr>
</table>
