<cfimport prefix="g" taglib="../../groovyEngine/tags" />

<g:script>
import java.text.SimpleDateFormat
import com.barneyb.Person

sdf = new SimpleDateFormat("yyy/MM/dd")
sdf.lenient = true
variables.myPerson = new Person([
	name: attributes.name ?: "Barney",
	dob: sdf.parse(attributes.dob ?: "1980/06/10")
])
</g:script>

<cfoutput>
<h1>Simple Objects</h1>

<p>Here we have the combination of a managed runtime with a Groovy path
and some inline Groovy.  The path in this case is used to house the
<code>com.barneyb.Person</code> class, which the inline script
instantiates and configures.
</p>

<p>Also on show is the transparent scope access within Groovy scripts and
use of Java APIs.
</p>

<h2>Output</h2>

<p>#myPerson.name# is #numberFormat(myPerson.ageInYears, ",0.00")# years old (thats #numberFormat(myPerson.ageInDays, ",")# days!).
</p>

<hr />
<hr />

<form>
<p>Enter your own info to learn about your age:
</p>
<table border="0">
<tr>
	<td><label for="f_name">Name:</label></td>
	<td><input id="f_name" name="name"<cfif structKeyExists(url, "name")> value="#url.name#"</cfif> /></td>
</tr>
<tr>
	<td><label for="f_dob">DOB:</label></td>
	<td><input id="f_dob" name="dob"<cfif structKeyExists(url, "dob")> value="#url.dob#"</cfif> /></td>
	<td><em>yyyy/mm/dd</em></td>
</tr>
<tr>
	<td></td>
	<td>
		<input type="submit" value="Go" />
		<input type="button" value="Clear" onclick="location.href='?';" />
	</td>
</tr>
</table>
</form>
</cfoutput>
