<cfcomponent>

	<cfset this.name = "cfgroovy_" & listLast(getDirectoryFromPath(getCurrentTemplatePath()), "/\") />
	
	<cfinclude template="../../groovyEngine/udf_buildcfgroovy.cfm" />

	<cffunction name="onRequestStart">
		<cfif NOT structKeyExists(application, "cfgroovy") OR structKeyExists(url, "reload")>
			<cfif structKeyExists(application, "cfgroovy")>
				<!---
				close the existing one before opening a new one
				--->
				<cfset application.cfgroovy.close() />
			</cfif>
			
			<!---
			This would be much better served by ColdSpring, but not for
			a demo.
			--->
			<cfset application.cfhibernate = buildHibernatePlugin() />
			<cfset application.cfhibernate.setEntityPath(getDirectoryFromPath(getCurrentTemplatePath()) & "entities") />
			<cfset application.cfhibernate.setColdFusionDsn("cfgroovydemo") />
			<cfset application.cfhibernate.setAnnotatedClasses(listToArray("com.barneyb.User")) />
			<cfset application.cfgroovy = buildCfGroovy() />
			<cfset application.cfgroovy.addPlugin(application.cfhibernate) />
			<cfset application.cfgroovy.configure() />
		</cfif>
		
		<cfset request.sess = application.cfhibernate.getSessionForRequest() />
	</cffunction>
	
	
	
	<cffunction name="onRequestEnd" access="public" output="false" returntype="void">
		<cfargument name="targetPage" type="string" required="true" />
		<cfset application.cfhibernate.closeRequest() />
	</cffunction>
	
	

	<cffunction name="onError" access="public" output="false" returnType="void">
		<cfargument name="exception" type="any" required="true" />
		<cfargument name="eventName" type="string" required="true" />
		<cfif structKeyExists(application, "cfhibernate")>
			<cfset application.cfhibernate.closeRequest() />
		</cfif>
		<cfthrow object="#exception#" />
	</cffunction>
	
	
	
	<cffunction name="onApplicationEnd">
		<cfargument name="appScope" />
		<cfif structKeyExists(appScope, "cfgroovy")>
			<!---
			close runtime when exiting
			--->
			<cfset appScope.cfgroovy.close() />
		</cfif>
	</cffunction>

</cfcomponent>