<cffunction name="renderMethods" output="false" returntype="string">
	<cfargument name="label" />
	<cfargument name="list" />
	<cfset var result = "" />
	<cfset var methods = structNew() />
	<cfset var s = "" />
	<cfset var params = "" />
	<cfset var i = "" />
	<cfset var j = "" />
	<cfloop from="1" to="#arrayLen(list)#" index="i">
		<cfset s = structNew() />
		<cftry>
			<cfset s.returnType = list[i].getReturnType() />
			<cfcatch type="any">
				<cfset s.returnType = "" />
			</cfcatch>
		</cftry>
		<cfset s.name = list[i].getName() />
		<cfset s.params = REReplace(list[i].toString(), "^.*\((.*)\).*$", "\1") /> />
		<cfset s.toString = list[i].toString() />
		<cfset methods[REReplace(s.name & "(" & s.params & ")", ",", "_", "all")] = s />
	</cfloop>
	<cfoutput>
	<cfsavecontent variable="result">
	<table>
	<tr>
		<th colspan="2">#label#</th>
	</tr>
	<cfloop list="#listSort(structKeyList(methods), 'textnocase')#" index="i">
		<tr>
			<td>
				<cfset rt = methods[i].returnType />
				<cfif structKeyExists(variables, "rt") AND NOT isSimpleValue(rt)>
					<a href="?clazz=#rt.getCanonicalName()#">#rt.getCanonicalName()#</a>
				</cfif>
			</td>
			<td>
				<strong style="color:blue;" title="#methods[i].toString#">#methods[i].name#</strong>(
				<cfloop list="#methods[i].params#" index="j">
					<cfif j CONTAINS ".">
						<a href="?clazz=#j#">#j#</a>
					<cfelse>
						#j#
					</cfif>,
				</cfloop>
				)
			</td>
		</tr>
	</cfloop>
	</table>
	</cfsavecontent>
	</cfoutput>
	<cfreturn REReplace(result, ",[[:space:]]*\)", ")", "all") />
</cffunction>

<cfset attributes = structNew() />
<cfset structAppend(attributes, form) />
<cfset structAppend(attributes, url) />

<cfoutput>
<cfparam name="attributes.clazz" default="coldfusion.tagext.sql.QueryTag" />
<cfset attributes.clazz = trim(attributes.clazz) />
<form method="get" action="?">
	<input name="clazz" value="#attributes.clazz#" />
	<input type="submit" />
</form>
<cfset c = getClass().forName(attributes.clazz) />
<h1><cfif c.isInterface()>Interface<cfelse>Class</cfif> #c.getCanonicalName()#</h1>
<cfset super = c.getSuperclass() />
<cfloop condition="structKeyExists(variables, 'super')">
	extends <a href="?clazz=#super.getCanonicalName()#">#super.getCanonicalName()#</a><br />
	<cfset super = super.getSuperclass() />
</cfloop>
<cfset interfaces = c.getInterfaces() />
<cfloop from="1" to="#arrayLen(interfaces)#" index="i">
	implements <a href="?clazz=#interfaces[i].getCanonicalName()#">#interfaces[i].getCanonicalName()#</a><br />
</cfloop>
#renderMethods("Constructors", c.getDeclaredConstructors())#
#renderMethods("Methods", c.getMethods())#
</cfoutput>