<cfparam name="url.page" default="install.cfm" />

<cfset url.page = REReplace(url.page, "[^a-zA-Z0-9_.]+", "_", "all") />

<cfset dir = getDirectoryFromPath(getCurrentTemplatePath()) />
<cfif fileExists(dir & url.page)>
	<cfset template = url.page />
<cfelseif directoryExists(dir & "examples/" & url.page)>
	<cfset template = "examples/" & url.page & "/index.cfm" />
<cfelse>
	<cfset template = "install.cfm" />
</cfif>

<cfoutput>
<html>
<head>
	<title>Groovy Demo</title>
	<link href="style.css" rel="stylesheet" type="text/css" />
	<script src="jquery.js" type="text/javascript"></script>
	<script type="text/javascript">
		jQuery.noConflict()
		jQuery(function() {
			jQuery.ajax({
				url: "#template#"<cfif structKeyExists(url, "reload")> + "?reload"</cfif>,
				complete: function(xhr, status) {
					jQuery("##content").html(xhr.responseText)
				}
			})
		})
	</script>
</head>
<body>
<div id="content">
	<h1>Loading...</h1>
</div>
<div id="nav">
	<h2>Installation</h2>
	
	<ul><li><a href="?page=install.cfm">Installation Instructions</a></li></ul>
	
	<h2>Groovy</h2>
	
	<ul>
		<li><a href="?page=inline_script">Inline Groovy</a></li>
		<li><a href="?page=external_script">Externalized Groovy</a></li>
		<li><a href="?page=managed_runtime">Managed Runtime</a></li>
		<li><a href="?page=simple_objects">Simple Objects</a></li>
		<li><a href="?page=comparators">Comparators</a></li>
	</ul>
	
	<h2>Hibernate</h2>
	<ul>
		<li><a href="?page=userlist_annotated">User List (Annotated)</a></li>
	</ul>
</div>
</body>
</html>
</cfoutput>
